﻿'「参照の設定」の「NuGetパッケージの管理」からWinRTXamlToolkitをインストールする。
' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください
Option Strict On
Imports Windows.Media.Capture
Imports Windows.Media.MediaProperties
Imports Windows.Storage
Imports Windows.Storage.Streams
Imports System.IO
Imports Windows.UI.Popups
''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    Dim myMediaCapture As MediaCapture
    Dim myCaptureInitSetting As MediaCaptureInitializationSettings
    Dim myProfile As MediaEncodingProfile
    Dim myMP4FileList As IReadOnlyList(Of IStorageFile)
    Dim flag As Boolean = False
    Dim myFileName As String
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        Dim fileList As New List(Of String)
        Dim myFolder = KnownFolders.VideosLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
        'Dim DataFile As IReadOnlyList(Of StorageFile) = Await mySubFolder.GetFilesAsync()
        myMP4FileList = Await mySubFolder.GetFilesAsync
        If myMP4FileList.Count > 0 Then
            For Each myFile In myMP4FileList
                fileList.Add(Path.GetFileNameWithoutExtension(myFile.Path) & ".mp4")
            Next
            fileNameListBox.ItemsSource = fileList
        End If

        myMediaCapture = New MediaCapture
        myCaptureInitSetting = New MediaCaptureInitializationSettings
        myCaptureInitSetting.AudioDeviceId = String.Empty
        myCaptureInitSetting.StreamingCaptureMode = StreamingCaptureMode.Audio
        Try
            Await myMediaCapture.InitializeAsync(myCaptureInitSetting)
            myProfile = MediaEncodingProfile.CreateMp4(VideoEncodingQuality.Auto)
        Catch
            messageTextBlock.Text = "マイクが機能していません。"
            ComboBox1.IsEnabled = False
            Exit Sub
        End Try

    End Sub

    Private Async Sub ComboBox1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles ComboBox1.SelectionChanged
        Try
            CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Visible
            Dim Index = DirectCast(ComboBox1.SelectedItem, ComboBoxItem)
            Dim myIndex As Integer = CInt(Index.Content)
            CountdownControl1.Seconds = myIndex
            myFileName = DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & ".mp4"
            Dim myFolder = KnownFolders.VideosLibrary
            Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
            Dim newFile = Await mySubFolder.CreateFileAsync(myFileName, CreationCollisionOption.OpenIfExists)
            Dim myStorageFile As StorageFile = newFile
            Dim result = myMediaCapture.StartRecordToStorageFileAsync(myProfile, myStorageFile)
            stopButton.IsEnabled = True
            messageTextBlock.Text = String.Empty
        Catch
            Exit Sub
        End Try
    End Sub


    Private Async Sub CountdownControl1_CountdownComplete(sender As Object, e As RoutedEventArgs) Handles CountdownControl1.CountdownComplete
        stopButton.IsEnabled = False

        Dim myDialog As New MessageDialog(myFileName & "を保存しますか?", "保存確認")
        If flag = True Then
            myDialog.Commands.Add(New UICommand("Cancel", Async Sub()
                                                              CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
                                                              messageTextBlock.Text = "保存を中止しました。"
                                                              Dim myFolder = KnownFolders.VideosLibrary
                                                              Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
                                                              Dim delFileList = Await mySubFolder.GetFilesAsync()
                                                              For Each result In delFileList
                                                                  If Path.GetFileNameWithoutExtension(result.Path) & ".mp4" = myFileName Then
                                                                      Await result.DeleteAsync()

                                                                  End If
                                                              Next
                                                              Exit Sub
                                                          End Sub))

            Await myDialog.ShowAsync
            ComboBox1.SelectedIndex = -1
            flag = False
        Else
            myDialog.Commands.Add(New UICommand("OK", Async Sub()
                                                          Dim fileList2 As New List(Of String)

                                                          Await myMediaCapture.StopRecordAsync()
                                                          messageTextBlock.Text = "保存しました。"
                                                          Dim myFolder = KnownFolders.VideosLibrary
                                                          Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
                                                          Dim myMP4FileList2 = Await mySubFolder.GetFilesAsync

                                                          For Each myFile In myMP4FileList2
                                                              fileList2.Add(Path.GetFileNameWithoutExtension(myFile.Path) & ".mp4")
                                                          Next
                                                          fileNameListBox.ItemsSource = fileList2
                                                          CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
                                                      End Sub))

            myDialog.Commands.Add(New UICommand("Cancel", Async Sub()
                                                              CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
                                                              messageTextBlock.Text = "保存を中止しました。"
                                                              Dim myFolder = KnownFolders.VideosLibrary
                                                              Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
                                                              Dim delFileList = Await mySubFolder.GetFilesAsync()
                                                              For Each result In delFileList
                                                                  If Path.GetFileNameWithoutExtension(result.Path) & ".mp4" = myFileName Then
                                                                      Await result.DeleteAsync()

                                                                  End If
                                                              Next
                                                              Exit Sub
                                                          End Sub))

            Await myDialog.ShowAsync
            ComboBox1.SelectedIndex = -1
            flag = False
        End If

    End Sub

   

    Private Sub MediaElement1_MediaEnded(sender As Object, e As RoutedEventArgs) Handles MediaElement1.MediaEnded
        ProgressRing1.IsActive = False
        ProgressRing1.IsEnabled = False
    End Sub

    Private Async Sub stopButton_Click(sender As Object, e As RoutedEventArgs) Handles stopButton.Click
        flag = True
        Await myMediaCapture.StopRecordAsync()
        Dim myFolder = KnownFolders.VideosLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
        Dim delFileList = Await mySubFolder.GetFilesAsync()
        For Each result In delFileList
            If Path.GetFileNameWithoutExtension(result.Path) & ".mp4" = myFileName Then
                Await result.DeleteAsync()
                CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
            End If
        Next

        CountdownControl1.Seconds = 1
        stopButton.IsEnabled = False
        CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
        ComboBox1.SelectedIndex = -1
        Exit Sub
    End Sub

    

    Private Async Sub fileNameListBox_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles fileNameListBox.SelectionChanged
        Try
            'ProgressRing1.Visibility = Windows.UI.Xaml.Visibility.Visible
            ProgressRing1.IsEnabled = True
            ProgressRing1.IsActive = True
            Dim fileList3 As New List(Of String)
            Dim myFolder = KnownFolders.VideosLibrary
            Dim mySubFolder = Await myFolder.CreateFolderAsync("SoundFile", CreationCollisionOption.OpenIfExists)
            Dim myMP4FileList3 = Await mySubFolder.GetFilesAsync

            For Each result In myMP4FileList3
                fileList3.Add(Path.GetFileNameWithoutExtension(result.Path) & ".mp4")
            Next
            Dim myFile = Await mySubFolder.GetFileAsync(fileList3(fileNameListBox.SelectedIndex))
            Dim myStream = Await myFile.OpenAsync(FileAccessMode.Read)

            MediaElement1.SetSource(myStream, myFile.ContentType)
            MediaElement1.Play()
        Catch
            ProgressRing1.IsEnabled = False
            ProgressRing1.IsActive = False
            Exit Sub
        End Try
    End Sub

End Class
